// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <vector>    // Get the standard vector template
#include <string>    // Get the standard string class
#include <algorithm> // Get the standard sort() function
using namespace std;

//#include "Car.hpp"  // Get the user-defined Car class
// Pretend file "Car.hpp" contains the following (this is from FAQ 2.17):

#include <string>
using namespace std;

class Car {
public:
  virtual void startEngine();     // Line 1
  virtual bool isRunning() const; // Line 2
  virtual void tuneRadioTo(const string& band, int freq); // Line 3
  friend bool operator<(const Car&, const Car&);
  friend bool operator==(const Car&, const Car&);
protected:
  bool isRunning_;                // Line 4
  bool radioOnAM_;
  int  radioFreq_;
};

void Car::startEngine()
{ isRunning_ = true; }

bool Car::isRunning() const
{ return isRunning_; }

void Car::tuneRadioTo(const string& band, int freq)
{ radioOnAM_ = (band == "AM"); radioFreq_ = freq; }

typedef vector<Car>    CarList;     // Synonym for convenience
typedef vector<string> StringList;  // Synonym for convenience

int main()
{
  CarList x;        // Create a vector of Car objects
  Car a, b, c;
  x.push_back(a);   // Append object a to the CarList x
  x.push_back(b);
  x.push_back(c);
  // ...

  StringList y;     // Create a vector of string objects
  y.push_back("Foo"); // Append string "Foo" to the StringList y
  y.push_back("Bar");
  y.push_back("Baz");
  sort(y.begin(), y.end()); // Sort the StringList y
  // ...
}
