// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <memory>   // To get auto_ptr
#include <iostream>
using namespace std;

class Engine {
public:
  Engine();
  virtual void start();
};

Engine::Engine()
{
  cout << "Engine constructor\n";
}

void Engine::start()
{
  cout << "Engine::start()\n";
}

typedef auto_ptr<Engine> EnginePtr;

class Car {
public:
  Car();
  virtual void startEngine();
  virtual ~Car();
  Car(const Car& c);  // This can be ignored for now; see FAQ [??big-three??]
  Car& operator= (const Car& c);  // This can be ignored for now; see FAQ [??big-three??]
protected:
  EnginePtr p_;  // Every Car object contains a pointer to its Engine object
};

Car::Car()
: p_ (new Engine())  // Allocate an Engine object for the Car object
{
  // Intentionally left blank
}

void Car::startEngine()
{
  p_->start();  // Call the start() member function of the Engine object
}
