// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Fred {
public:
  int f(int i);
    // REQUIRE: Parameter i must be odd
    //   (if i is odd, this doesn't guarantee to fulfill its PROMISE.)
    // PROMISE: Return value will be some even number
};

int Fred::f(int i)
{
  if (i % 2 == 0) {
    // This could throw an exception here, but doesn't have to
  }

  // This is allowed to return any even number,
  // but it can do something very specific if desired...
  return 8;
}

int main()
{
  Fred fred;
  int result = fred.f(37);
  // This is allowed to assume that result is even
  // (but it's not allowed to assume result is 8.)
}
