// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  Base() throw();
  virtual ~Base() throw();
  virtual void f() throw();
};

Base::Base()
{ }

Base::~Base()
{ }

void Base::f() throw()
{ cout << "Base::f()\n" << flush; }

class Derived : public Base {
public:
  Derived() throw();
  virtual void f() throw();
protected:
  int i_;
};

Derived::Derived() throw()
: Base()
, i_(42)
{ }

void Derived::f() throw()
{ cout << "Derived::f()\n" << flush; }

void sample(Base* b) throw()
{
  cout << "b[0].f(): " << flush;
  b[0].f();
  cout << "b[1].f(): " << flush;
  b[1].f();                       // Bang!
}

int main()
{
  Derived d[10];
  sample(d);
}
