// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <vector>
#include <iostream>
using namespace std;

//#include "Base.hpp"
// Pretend file "Base.hpp" contains the following (this is from FAQ 8.16):
class Base {
public:
  Base() throw();
  virtual ~Base() throw();
  virtual void f() throw();
  friend bool operator<(const Base&, const Base&);
  friend bool operator==(const Base&, const Base&);
};

Base::Base()
{ }

Base::~Base()
{ }

void Base::f() throw()
{ cout << "Base::f()\n" << flush; }

void sample(vector<Base>& a) throw()
{
  cout << "a[0].f(): ";
  a[0].f();
  cout << "a[1].f(): ";
  a[1].f();
}

int main()
{
  vector<Base> b(10);
  sample(b);

  #ifdef GENERATE_ERROR
    vector<Derived> d(10);
    sample(d);             // Error caught at compile time (fortunately)
  #endif
}
