// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Vehicle {
public:
  virtual void startEngine() throw() = 0;
  virtual ~Vehicle() throw();
};

Vehicle::~Vehicle() throw()
{ }

class V8Engine {
public:
  void start() throw();
};

void V8Engine::start() throw()
{ cout << "starting V8Engine\n"; }

class Car : public Vehicle {
public:
  virtual void startEngine() throw();
protected:
  V8Engine engine_;
};

void Car::startEngine() throw()
{ engine_.start(); }

void f(Vehicle& v) throw()
{ v.startEngine(); }

int main()
{
  Car c;
  f(c);
}
