// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class BinaryTreeNode;  // Predeclare class BinaryTreeNode

class BinaryTree {
public:
  friend ostream& operator<< (ostream& ostr, const BinaryTree& bt) throw();
     // operator<< can access BinaryTree
protected:
  BinaryTreeNode* root_;
};

class BinaryTreeNode {
public:
  // public interface for BinaryTreeNode goes here...
private:
  friend BinaryTree;     // BinaryTree can access BinaryTreeNode
  BinaryTreeNode* left_;
  BinaryTreeNode* right_;
};

ostream& operator<< (ostream& ostr, const BinaryTree& bt) throw()
{
  // This code can access bt.root_ (it's a friend of BinaryTree),
  // but it can't access bt.root_->left_ (it's not a friend of BinaryTreeNode).
  return ostr;
}
