// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class X {
public:
  X()         throw();
  X(const X&) throw();
};

X::X()         throw() { cout << "default constructor\n"; }
X::X(const X&) throw() { cout << "copy constructor\n";    }

X userCode(X b) throw()  // pass by value: copy main()'s a to b
{
  X c = b;  // explicit copy: copy from b to c
  return c;
}           // return by value: copy from c to main()'s d

int main()
{
  X a;
  cout << "calling userCode()\n";
  X d = userCode(a);
  cout << "back in main()\n";
}
