// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  Fred(int x)   throw();
  Fred(float y) throw();
  Fred(char* z) throw();
  // ...
private:
  void init(int x, float y, char* z) throw();
  // ...
};

inline Fred::Fred(int x)   throw() { init(x, 0.3, NULL); }
inline Fred::Fred(float y) throw() { init(-1, y, "foo"); }
inline Fred::Fred(char* z) throw() { init(-2, 5.2, z);   }

void Fred::init(int x, float y, char* z) throw()
{
  // ...
}
