// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fract {
public:
  Fract(int numerator=0, int denominator=1) throw();
  int numerator()   const throw();
  int denominator() const throw();
  friend Fract operator+ (const Fract& a, const Fract& b) throw();
  friend Fract operator- (const Fract& a, const Fract& b) throw();
  friend Fract operator* (const Fract& a, const Fract& b) throw();
  friend Fract operator/ (const Fract& a, const Fract& b) throw();
  friend ostream& operator<< (ostream& ostr, const Fract& a) throw();
protected:
  int num_;  //numerator
  int den_;  //denominator
};

Fract::Fract(int numerator, int denominator)
: num_(numerator)
, den_(denominator)
{ }

int Fract::numerator()   const throw() { return num_; }
int Fract::denominator() const throw() { return den_; }

ostream& operator<< (ostream& ostr, const Fract& a) throw()
{ return ostr << a.num_ << '/' << a.den_; }

int main()
{
  Fract a;                cout << "a = " << a << endl;
  Fract b = 5;            cout << "b = " << b << endl;
  Fract c = Fract(22,7);  cout << "c = " << c << endl;
}
