// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Y {
public:
  Y()      throw();
  void f() throw();
};

Y::Y()      throw() { cout << "Y ctor\n"; }
void Y::f() throw() { cout << "Y used\n"; }

class X {
public:
  X(Y& y) throw();
};

X::X(Y& y) throw() { y.f(); }

class Z {
public:
  Z() throw();
protected:
  X x_;
  Y y_;
};

Z::Z() throw()
: y_()
, x_(y_)  // Bad form: should have listed x_ before y_
{ }

int main()
{ Z z; }
