// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"
#include <stdexcept>
using namespace std;

class Array {
public:
  int& elem(unsigned i) throw(out_of_range);
protected:
  int data_[100];
};

inline int& Array::elem(unsigned i) throw(out_of_range)
{ return data_[i]; }

void sample()
{
  Array a;
  a.elem(10) = 42;
  a.elem(12) = 10;
  a.elem(12) += a.elem(10);
}

class Array2 {
public:
  int& operator[] (unsigned i) throw(out_of_range);
protected:
  int data_[100];
};

inline int& Array2::operator[] (unsigned i) throw(out_of_range)
{ return data_[i]; }

void sample2()
{
  Array2 a;
  a[10] = 42;
  a[12] = 10;
  a[12] += a[10];
}

int main()
{
  sample();
  sample2();
}
