// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <iostream>
#include <cstring>
using namespace std;

class String {
public:
  String()                            throw(bad_alloc);
  String(const char* s)               throw(bad_alloc);
  String(const String& s)             throw(bad_alloc);
 ~String()                            throw();
  String& operator= (const String& s) throw(bad_alloc);
protected:
  unsigned len_;
  char*    data_;
};

String& String::operator= (const String& s) throw(bad_alloc)
{
  if (s.len_ > len_) {  // Makes self-assignment harmless; no need to explictly test
    char* newData = new char[s.len_+1];
    delete[] data_;
    data_ = newData;
  }
  memcpy(data_, s.data_, s.len_+1);
  len_ = s.len_;
  return *this;
}
