// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Base {
public:
  Base& operator= (const Base& b) throw();
protected:
  int i_;
};

Base& Base::operator= (const Base& b) throw()
{
  i_ = b.i_;
  return *this;
}

class Derived : public Base {
public:
  Derived& operator= (const Derived& d) throw();
protected:
  int j_;
};

Derived& Derived::operator= (const Derived& d) throw()
{
  Base::operator= (d);
  j_ = d.j_;
  return *this;
}
