// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cstdlib>
#include <iostream>
using namespace std;

class Fred   { };
class Wilma  { };

void sample() throw(Fred)
{
  switch (rand() % 3) {
    case 0:
      cout << "throwing a Fred; ";
      throw Fred();
    case 1:
      cout << "throwing a Wilma; ";
      throw Wilma();  // Danger
    default:
      cout << "returning normally; ";
  }
}

#include <exception>

void myUnexpected() throw()
{
  cout << "unexpected exception!" << endl;
  terminate();  // Good night Nurse!
}

int main()
{
  // Without this, the program would silently crash:
  set_unexpected(myUnexpected);

  for (int i = 0; i < 10; ++i) {
    try {
      cout << "trying: ";
      sample();
      cout << "no exception thrown\n";
    }
    catch (Fred) {
      cout << "caught a Fred\n";
    }
    catch (Wilma) {
      cout << "caught a Wilma\n";
    }
    catch (...) {
      cout << "this should never happen\n";
    }
  }
}
