// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Position { };

class Shape {
public:
  virtual ~Shape() throw();
  virtual void draw() const throw() = 0;
  virtual int  dist(Position mouse) const throw() = 0;
};

Shape::~Shape() throw()
{ }

class Circle : public Shape {
public:
  virtual void draw() const throw();
  virtual int dist(Position mouse) const throw();
};

void Circle::draw() const throw()
{ /*draw a Circle*/ }

int Circle::dist(Position mouse) const throw()
{ int d; /*set 'd' to distance from mouse to this Circle*/ return d; }

class Square : public Shape {
public:
  virtual void draw() const throw();
  virtual int dist(Position mouse) const throw();
};

void Square::draw() const throw()
{ /*draw a Square*/ }

int Square::dist(Position mouse) const throw()
{ int d; /*set 'd' to distance from mouse to this Square*/ return d; }

class Line : public Shape {
public:
  virtual void draw() const throw();
  virtual int dist(Position mouse) const throw();
};

void Line::draw() const throw()
{ /*draw a Line*/ }

int Line::dist(Position mouse) const throw()
{ int d; /*set 'd' to distance from mouse to this Line*/ return d; }

int dist_BAD_FORM(Shape& s, Position mouse) throw()
{
  int dist = 0;
  Circle* cp = dynamic_cast<Circle*>(&s);
  Square* sp = dynamic_cast<Square*>(&s);
  Line*   lp = dynamic_cast<Line*>(&s);

  if (cp != NULL) {
    //set 'dist' to distance from mouse to the Circle, *cp
  } else if (sp != NULL) {
    //set 'dist' to distance from mouse to the Square, *sp
  } else if (lp != NULL) {
    //set 'dist' to distance from mouse to the Line, *lp
  }
  return dist;
}
