// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Asset {
public:
  virtual ~Asset() throw();
  virtual int tryToLiquidate() throw();
};

Asset::~Asset() throw()
{ }

int Asset::tryToLiquidate() throw()
{
  cout << "Sorry, couldn't liquidate this asset\n";
  return 0;
}

class LiquidAsset : public Asset {
public:
  LiquidAsset(int value=100) throw();
  virtual int tryToLiquidate() throw();
protected:
  int value_;    //value of this asset
};

LiquidAsset::LiquidAsset(int value) throw()
: value_(value) { }

int LiquidAsset::tryToLiquidate() throw()
{
  int value = value_;
  value_ = 0;
  cout << "Liquidated $" << value << '\n';
  return value;
}

int sample(Asset& asset)
{ return asset.tryToLiquidate(); }

int main()
{
  Asset       a;
  LiquidAsset b;

  sample(a);
  sample(b);
}
