// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Shape {
public:
  virtual ~Shape() throw();
  // ...
};

Shape::~Shape() throw() { }

class Circle : public Shape { /*...*/ };
class Square : public Shape { /*...*/ };

void sample(Shape* p) throw()
{
  Circle* cp = dynamic_cast<Circle*>(p);
  if (cp != NULL) {
    cout << "The object is a Circle\n";
  } else {
    cout << "The object is not a Circle\n";
  }
}

int main()
{
  Circle c;
  Square s;
  sample(&c);
  sample(&s);
}
