// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual ~Base()         throw();
  virtual void f(int x)   throw();
  virtual void f(float x) throw();
};

Base::~Base() throw()
{ }

void Base::f(int x) throw()
{ cout << "Base::f(int)\n"; }

void Base::f(float x) throw()
{ cout << "Base::f(float)\n"; }

class Derived : public Base {
public:
  virtual void f(int x) throw();
  using Base::f;  // This un-hides f(float) (good!)
};

void Derived::f(int x) throw()
{ cout << "Derived::f(int)\n"; }

void sample(Base& b, Derived& d)
{
  b.f(42);
  d.f(42);

  b.f(3.14f);
  d.f(3.14f);  // This is not hidden (good!)
}

int main()
{
  Derived d;
  sample(d, d);
}
