// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Member {
public:
  Member() throw();
  Member(const Member&) throw();
};

Member::Member() throw()
{ cout << "constructing a Member\n"; }

Member::Member(const Member&) throw()
{ cout << "copying a Member\n"; }

class Fred {
public:
  Fred() throw();
  // Fred doesn't have an explicit copy constructor
protected:
  Member member_;
};

Fred::Fred() throw()
: member_()
{ }

int main()
{
  Fred a;
  Fred b = a;  // Compiler's synthesized copy constructor Fred::Fred(const Fred&) called here
}
