// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cstring>

class MyString {
public:
  MyString(const char* s) throw();
 ~MyString() throw();
  MyString(const MyString& s) throw();
  MyString& operator= (const MyString& s) throw();
protected:
  unsigned len_;     // ORDER DEPENDENCY; see FAQ 22.10
  char*    data_;    // ORDER DEPENDENCY; see FAQ 22.10
};

MyString::MyString(const char* s) throw()
: len_(strlen(s))
, data_(new char[len_ + 1])
{ memcpy(data_, s, len_ + 1); }

MyString::~MyString() throw()
{ delete[] data_; }

int main()
{ MyString s = "xyzzy"; }
