// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <cstring>
using namespace std;

// a and b point to char*s
int compareCharPtr(const void* a, const void* b) throw()
{ return strcmp(*(char**)a, *(char**)b); }

void theWrongWay() throw()
{
  const unsigned maxNumWords = 1000;
  const unsigned maxWordLen = 100;
  char word[maxWordLen];
  unsigned uniqueSize = 0;
  unsigned uniqueCapacity = 100;
  char** unique = (char**) malloc(uniqueCapacity * sizeof(char*));
  if (unique == NULL)      // Problem #1
    return;
  while (cin >> word) {    // Problem #2
    unsigned i;
    for (i = 0; i < uniqueSize; ++i)
      if (strcmp(unique[i], word) == 0)  // Problem #3
        break;
    if (i == uniqueSize) {
      if (uniqueSize == uniqueCapacity) {
        uniqueCapacity *= 2;
        unique = (char**) realloc(unique, uniqueCapacity * sizeof(char*));
        if (unique == NULL) // Problem #4
          return;
      }
      unique[uniqueSize++] = strdup(word);
    }
  }
  qsort(unique, uniqueSize, sizeof(unique[0]), compareCharPtr);
  for (unsigned i = 0; i < uniqueSize; ++i)
    cout << unique[i] << '\n';
  for (unsigned j = 0; j < uniqueSize; ++j)
    free(unique[j]);
  free(unique);
}

int main()
{ theWrongWay(); }
