// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <memory>
using namespace std;

class Fred {
public:
  ~Fred() throw();
};

Fred::~Fred() throw()
  { cout << "Fred dtor\n"; }

void sample() throw(bad_alloc)
{
  auto_ptr<Fred> ptr( new Fred() );

  if (rand() % 2) {
    cout << "randomly doing an 'early return'\n";
    return;
  }
  cout << "randomly NOT doing an 'early return'\n";
     // In either case, we do NOT say delete ptr, since ptr is a managed pointer
}

int main()
{ sample(); }
