// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <string>
using namespace std;

void checkForNull(const string& nameOfPointer, char* p)
{
  cout << nameOfPointer;
  if (p == NULL)
    cout << " is NULL\n";
  else
    cout << " is not NULL\n";
}

int main()
{
  checkForNull("0", 0);       // OK: the NULL pointer
  checkForNull("NULL", NULL); // OK: the NULL pointer

  char* memsetPtr;
  memset(&memsetPtr, '\0', sizeof(memsetPtr));  // BAD: undefined pointer!
  checkForNull("memsetPtr", memsetPtr);
}

union Fred {
  unsigned long n;
  char* p;
};

void badForm()
{
  Fred x;
  x.n = 0;  // OK: set the unsigned long member to 0
  char* unionPtr = x.p;  // BAD: the char* member isn't defined!
  checkForNull("unionPtr", unionPtr);
}
