// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Shape {
public:
  virtual void draw() const throw() = 0;
  virtual ~Shape() throw();
};

Shape::~Shape() throw()
{ }

class Circle : public Shape {
public:
  /*final*/ void draw() const throw();
};

inline void Circle::draw() const throw() // Note the inline even though it is virtual
{
  // ...
}

void sample(Circle& c) throw()
{
  c.Circle::draw();
}
