// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

/****** Bilingual C/C++ header file: Fred.h ******/
#ifdef __cplusplus
  class Fred {
  public:
    Fred() throw();
    void wilma(int i) throw();
  protected:
    int i_;
  };
  inline Fred::Fred() throw() : i_(0) { }
  inline void Fred::wilma(int i) throw() { i_ = i; }
#else
  struct Fred {
    int i_;
  };
  typedef  struct Fred  Fred;
#endif

#ifdef __cplusplus
  extern "C" {
#endif

extern void cppCallingC(Fred* p);
extern void cCallingCpp(Fred* p, int param);

#ifdef __cplusplus
  }
#endif

// This is C++ code
#include "Fred.h"

void cCallingCpp(Fred* p, int param) throw()
  { p->wilma(param); }

/* This is C code */
#include "Fred.h"

void cppCallingC(Fred* p)
  { cCallingCpp(p, 3); }

// This is C++ code
#include "Fred.h"

int main()
{
  Fred x;
  cppCallingC(&x);
}
