// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  void f(int i) throw();
  void g(int i) throw();
  void h(int i) throw();
};

void Fred::f(int i) throw()
  { cout << "Fred::f(int); i=" << i << '\n'; }
void Fred::g(int i) throw()
  { cout << "Fred::g(int); i=" << i << '\n'; }
void Fred::h(int i) throw()
  { cout << "Fred::h(int); i=" << i << '\n'; }

typedef void(Fred::*FredMemberPtr)(int);

void sample(Fred& x, FredMemberPtr p) throw()
{ (x.*p)(42); }  // If p is &Fred::g, this is the same as x.g(42)

int main()
{
  FredMemberPtr p = &Fred::g;
  Fred x;
  sample(x, p);
}
